//---------------------------------------------------------------------------
//		Copyright (C) 1991-93, Microsoft Corporation
//
// You have a royalty-free right to use, modify, reproduce and distribute
// the Sample Custom Control Files (and/or any modified version) in any way
// you find useful, provided that you agree that Microsoft has no warranty,
// obligation or liability for any Custom Control File.
//---------------------------------------------------------------------------
// valve.h
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Resource Information
//---------------------------------------------------------------------------
// Toolbox bitmap resource IDs numbers.
//---------------------------------------------------------------------------
#define IDBMP_VALVE			8000
#define IDBMP_VALVEDOWN		8001
#define IDBMP_VALVEMONO		8003
#define IDBMP_VALVEEGA 		8006

//---------------------------------------------------------------------------
// Change these for each new VBX file
//---------------------------------------------------------------------------
#define VBX_COMPANYNAME 	   	"Edward B. Toupin\0"
#define VBX_FILEDESCRIPTION	   "Visual Basic Valve Custom Control\0"
#define VBX_INTERNALNAME	   	"VALVE\0"
#define VBX_LEGALCOPYRIGHT	   	"Copyright \251 Edward B. Toupin 1994\0"
#define VBX_LEGALTRADEMARKS	   "Microsoft\256 is a registered trademark of Microsoft Corporation. Visual Basic\231 is a trademark of Microsoft Corporation. Windows\231 is a trademark of Microsoft Corporation.\0"
#define VBX_ORIGINALFILENAME	   "VALVE.VBX\0"
#define VBX_PRODUCTNAME 	   	"Microsoft\256 Visual Basic\231 for Windows\231\0"

//---------------------------------------------------------------------------
// Update these fields for each build.
//---------------------------------------------------------------------------
#define VBX_VERSION		    3,00,0,00
#define VBX_VERSION_STR 	   "3.00.000\0"

//---------------------------------------------------------------------------
// Constants used by dialog boxes
//---------------------------------------------------------------------------
#define DI_OK	      1
#define DI_CANCEL     2
#define DI_REDOPT     105
#define DI_GREENOPT   106
#define DI_BLUEOPT    107

#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Macro for referencing member of structure
//---------------------------------------------------------------------------
#define OFFSETIN(struc, field)	    ((USHORT)&(((struc *)0)->field))


//---------------------------------------------------------------------------
// Control and Window Procedures
//---------------------------------------------------------------------------
LONG FAR PASCAL _export ValveCtlProc(HCTL, HWND, USHORT, USHORT, LONG);
LONG FAR PASCAL _export FlashPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp);


//---------------------------------------------------------------------------
// Global Variables and Constants
//---------------------------------------------------------------------------
extern	HANDLE hmodDLL;     // From ccinit.c
#define CLASS_FLASHPOPUP    "FCPopup"


//---------------------------------------------------------------------------
// CIRCLE control data and structs
//---------------------------------------------------------------------------
typedef struct tagVALVE
	{
    RECT    rectDrawInto;
	ENUM    ValveState;    // Changed from SHORT to demonstrate ENUM prop
	LONG    FlashColor;
	HFONT   hfont;
	HSZ     hszCaption;
	} VALVE;

typedef VALVE FAR * LPVALVE;

#define LpvalveDEREF(hctl)     ((LPVALVE)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Private messages
//---------------------------------------------------------------------------
#define CM_OPENFLASHDLG     WM_USER


//---------------------------------------------------------------------------
// Property info
//---------------------------------------------------------------------------
// List of enumeration for CircleShape ENUM property
#define STATE_OFF		0
#define STATE_ON		1
#define STATE_TRANS		2
#define STATE_ERROR		3
#define STATE_OPNING 	4
#define STATE_CLSING	5
#define STATE_MAX		5

PROPINFO Property_ValveState =
    {
    "ValveState",
    // Changed from SHORT to demonstrate an ENUM property
	DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSaveData | PF_fSetMsg | PF_fGetMsg ,
    OFFSETIN(VALVE, ValveState),
	8,
	 STATE_OFF,
	 "0 - Off\0" "1 - On\0" "2 - Trans\0" "3 - Error\0" "4 - Opening\0" "5 - Closing\0",
	 STATE_MAX
    };

PROPINFO Property_FlashColor =
    {
    "FlashColor",
    DT_COLOR | PF_fGetData | PF_fSetData | PF_fSaveData | PF_fEditable,
	 OFFSETIN(VALVE, FlashColor),
	0, 0, NULL, 0
    };

//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_VALVE_CTLNAME		  		 0
#define IPROP_VALVE_INDEX                1
#define IPROP_VALVE_BACKCOLOR            2
#define IPROP_VALVE_LEFT                 3
#define IPROP_VALVE_TOP                  4
#define IPROP_VALVE_WIDTH                5
#define IPROP_VALVE_HEIGHT               6
#define IPROP_VALVE_VISIBLE              7
#define IPROP_VALVE_PARENT               8
#define IPROP_VALVE_DRAGMODE             9
#define IPROP_VALVE_DRAGICON            10
#define IPROP_VALVE_TAG                 11
#define IPROP_VALVE_STATE         		12
#define IPROP_VALVE_FLASHCOLOR          13
#define IPROP_VALVE_CAPTION             14
#define IPROP_VALVE_FONTNAME            15
#define IPROP_VALVE_FONTBOLD            16
#define IPROP_VALVE_FONTITALIC          17
#define IPROP_VALVE_FONTSTRIKE          18
#define IPROP_VALVE_FONTUNDER           19
#define IPROP_VALVE_FONTSIZE            20
#define IPROP_VALVE_BORDERSTYLE	 		21
#define IPROP_VALVE_TABINDEX		 	22
#define IPROP_VALVE_TABSTOP		 		23
#define IPROP_VALVE_ENABLED		 		24
#define IPROP_VALVE_MOUSEPOINTER	 	25
#define IPROP_VALVE_HWND            	26
#define IPROP_VALVE_HELPCONTEXTID   	27
#define IPROP_VALVE_DATASOURCE      	28
#define IPROP_VALVE_DATAFIELD       	29
#define IPROP_VALVE_DATACHANGED     	30
#define IPROP_VALVE_LINKMODE	     	31
#define IPROP_VALVE_LINKITEM	     	32
#define IPROP_VALVE_LINKTOPIC	     	33
#define IPROP_VALVE_LINKTIMEOUT	     	34

PPROPINFO Valve_Properties[] =
    {
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TAG,
	&Property_ValveState,
	&Property_FlashColor,
	PPROPINFO_STD_CAPTION,
    PPROPINFO_STD_FONTNAME,
    PPROPINFO_STD_FONTBOLD,
    PPROPINFO_STD_FONTITALIC,
    PPROPINFO_STD_FONTSTRIKE,
    PPROPINFO_STD_FONTUNDER,
    PPROPINFO_STD_FONTSIZE,
    PPROPINFO_STD_BORDERSTYLEOFF,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_HWND,
    PPROPINFO_STD_HELPCONTEXTID,
    PPROPINFO_STD_DATASOURCE,
    PPROPINFO_STD_DATAFIELD,
	PPROPINFO_STD_DATACHANGED,
	PPROPINFO_STD_LINKMODE,
	PPROPINFO_STD_LINKITEM,	  
	PPROPINFO_STD_LINKTOPIC,  
	PPROPINFO_STD_LINKTIMEOUT,
	NULL
    };


//---------------------------------------------------------------------------
// Event info
//---------------------------------------------------------------------------
WORD Paramtypes_ClickIn[] = {ET_R4, ET_R4, ET_SD};

EVENTINFO Event_ClickIn =
    {
	"ClickIn",3,6,Paramtypes_ClickIn,
    "X As Single,Y As Single,Caption As String"
    };

EVENTINFO Event_ClickOut =
    {
	"ClickOut",0,0,NULL,NULL
	};


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define IEVENT_VALVE_CLICKIN		  0
#define IEVENT_VALVE_CLICKOUT		  1
#define IEVENT_VALVE_DRAGDROP		  2
#define IEVENT_VALVE_DRAGOVER		  3

PEVENTINFO Valve_Events[] =
    {
	&Event_ClickIn,&Event_ClickOut,PEVENTINFO_STD_DRAGDROP,
	PEVENTINFO_STD_DRAGOVER,NULL
    };


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
MODEL modelValve =
    {
    VB_VERSION, 			// VB version being used
    MODEL_fFocusOk | MODEL_fLoadMsg,			// MODEL flags
    (PCTLPROC)ValveCtlProc,		// Control procedure
    CS_VREDRAW | CS_HREDRAW,		// Class style
    0L, 				// Default Windows style
	sizeof(VALVE),			// Size of VALVE structure
    IDBMP_VALVE,			// Palette bitmap ID
    "Valve",				// Default control name
    "VALVE",				// Visual Basic class name
    NULL,				// Parent class name
    Valve_Properties,			// Property information table
    Valve_Events,			// Event information table
	IPROP_VALVE_STATE,		// Default property
	IEVENT_VALVE_CLICKIN,		// Default event
	IPROP_VALVE_STATE		// Property representing value of ctl
    };

LPMODEL modellistValve[] =
    {
    &modelValve,
    NULL
    };

MODELINFO modelinfoValve =
    {
    VB_VERSION, 			// VB version being used
    modellistValve			// MODEL list
    };

#endif	// RC_INVOKED

//---------------------------------------------------------------------------
